summaryrefslogtreecommitdiffstats
path: root/desktop/weston/weston.SlackBuild
diff options
context:
space:
mode:
author Logan Rathbone2019-11-02 19:27:55 +0100
committer Willy Sudiarto Raharjo2019-11-02 19:27:55 +0100
commitb32c9f8ba901f68df11d723c11ac99b3e717f5ce (patch)
tree57437a166db33ec01783bfc675f17a4b7e68918d /desktop/weston/weston.SlackBuild
parent833a418a9448f32874014c89bf70b7f065bdb220 (diff)
downloadslackbuilds-b32c9f8ba901f68df11d723c11ac99b3e717f5ce.tar.gz
desktop/weston: Added (Reference implementation of a Wayland).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'desktop/weston/weston.SlackBuild')
-rw-r--r--desktop/weston/weston.SlackBuild199
1 files changed, 199 insertions, 0 deletions
diff --git a/desktop/weston/weston.SlackBuild b/desktop/weston/weston.SlackBuild
new file mode 100644
index 0000000000..676942b4c4
--- /dev/null
+++ b/desktop/weston/weston.SlackBuild
@@ -0,0 +1,199 @@
+#!/bin/sh
+
+# Slackware build script for Weston
+
+# Copyright 2019 Logan Rathbone <poprocks@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=weston
+VERSION=${VERSION:-7.0.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.xz
+cd $PRGNAM-$VERSION
+
+# If you have PAM installed on your system and would like to make use
+# of it, run this as USE_PAM=true ./weston.Slackbuild
+# otherwise, a patch will be applied to remove the PAM dependency.
+
+USE_PAM=${USE_PAM:-false}
+
+if [ "$USE_PAM" != 'true' ]; then
+ patch -p1 < $CWD/weston-7.0.0-nopam.patch
+fi
+
+# Make sure ownerships and permissions are sane:
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# "./configure"
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+meson build/ \
+ --prefix=/usr \
+ --mandir=man \
+ --libdir=lib${LIBDIRSUFFIX} \
+ -Dlauncher-logind=false \
+ -Dbackend-rdp=false \
+ -Dsystemd=false \
+ -Dpipewire=false \
+ -Dsimple-dmabuf-drm=auto \
+ -Dcolor-management-colord=${USE_COLORD:-false}
+
+# "make"
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+ninja -C build
+
+# "make install"
+DESTDIR=$PKG ninja -C build/ install
+
+# strip
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+# Install /etc/profile.d scripts.
+mkdir -p $PKG/etc/profile.d/
+
+cat << 'EOF' > $PKG/etc/profile.d/${PRGNAM}.sh.new
+#!/bin/sh
+if test -z "${XDG_RUNTIME_DIR}"; then
+ export XDG_RUNTIME_DIR=/tmp/${UID}-runtime-dir
+ if ! test -d "${XDG_RUNTIME_DIR}"; then
+ mkdir "${XDG_RUNTIME_DIR}"
+ chmod 0700 "${XDG_RUNTIME_DIR}"
+ fi
+fi
+EOF
+
+cat << 'EOF' > $PKG/etc/profile.d/${PRGNAM}.csh.new
+#!/bin/csh
+if ( ! $?XDG_RUNTIME_DIR ) then
+ setenv XDG_RUNTIME_DIR /tmp/${uid}-runtime-dir
+ if ( ! -d $XDG_RUNTIME_DIR ) then
+ mkdir "${XDG_RUNTIME_DIR}"
+ chmod 0700 "${XDG_RUNTIME_DIR}"
+ endif
+endif
+EOF
+
+chmod 644 $PKG/etc/profile.d/${PRGNAM}*.new
+
+# setup doinst script...
+
+mkdir -p $PKG/install
+
+cat << 'EOF' > $PKG/install/doinst.sh
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+
+ config $NEW
+}
+
+EOF
+
+# config-ify the profile.d stuff
+
+# FIXME - I tried many things to try to creatively preserve the perms
+# of weston-launch as well (ie, in case someone suid's it and wants to
+# keep it that way upon upgrade), but this is really difficult if not
+# impossible to implement with Slackware's packaging system without
+# allowing for stray binaries (which would have been setuid by the
+# user) lingering around, which I'd really rather avoid, for safety.
+#
+# At this juncture, users will simply have to manually setuid-root the
+# binary upon each upgrade.
+
+cat << EOF >> $PKG/install/doinst.sh
+preserve_perms etc/profile.d/${PRGNAM}.sh.new
+preserve_perms etc/profile.d/${PRGNAM}.csh.new
+
+EOF
+
+# Install some documentation and finish up.
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a COPYING README.md CONTRIBUTING.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+cat $CWD/README > $PKG/usr/doc/$PRGNAM-$VERSION/README.Slackware
+
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}